jjb: Add workaround for newer pahole versions with focal kernels
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
index e016e135173081916b6c728f8daa22e7448970a7..6a96fc098610bc4218d525e6a4e9d3ad4ca23d6e 100644 (file)
@@ -1,6 +1,6 @@
-#!/bin/bash -exu
+#!/bin/bash
 #
-# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
+# Copyright (C) 2016-2019 Michael Jeanson <mjeanson@efficios.com>
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
+set -exu
+
 # Parameters
-arch=${arch:-}
+platforms=${platforms:-}
+# Derive arch from label if it isn't set
+if [ -z "${arch:-}" ] ; then
+    # Labels may be platform specific, eg. jammy-amd64, deb12-armhf
+    regex='[[:alnum:]]+-([[:alnum:]]+)'
+    if [[ "${platforms}" =~ ${regex} ]] ; then
+        arch="${BASH_REMATCH[1]}"
+    else
+        arch="${platforms:-}"
+    fi
+fi
+
 cross_arch=${cross_arch:-}
 ktag=${ktag:-}
 kgitrepo=${kgitrepo:-}
 mversion=${mversion:-}
 mgitrepo=${mgitrepo:-}
+make_args=()
 
+DEBUG=${DEBUG:-}
 
 ## FUNCTIONS ##
 
@@ -32,6 +47,7 @@ verlte() {
 }
 
 verlt() {
+    # shellcheck disable=SC2015
     [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
 }
 
@@ -40,13 +56,21 @@ vergte() {
 }
 
 vergt() {
+    # shellcheck disable=SC2015
     [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
 }
 
-
 git_clone_modules_sources() {
     mkdir -p "$MODULES_GIT_DIR"
-    git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
+
+    # If the version starts with "refs/", checkout the specific git ref, otherwise treat it
+    # as a branch name.
+    if [ "${mversion:0:5}" = "refs/" ]; then
+        git clone --no-tags --depth=1 "${mgitrepo}" "$MODULES_GIT_DIR"
+        (cd "$MODULES_GIT_DIR" && git fetch origin "${mversion}" && git checkout FETCH_HEAD)
+    else
+        git clone --no-tags --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
+    fi
 }
 
 # Checkout a shallow kernel tree of the specified tag
@@ -71,7 +95,7 @@ upload_archive_obj() {
 
 
 extract_archive_obj() {
-    tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
+    tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR" -I pbzip2
     rm -f "$WORKSPACE/$obj_name"
 }
 
@@ -82,6 +106,16 @@ tar_archive_obj() {
     cd -
 }
 
+list_gccs() {
+    local gccs
+    gccs=()
+    IFS=: read -r -a path_array <<< "$PATH"
+    while read -r gcc ; do
+        gccs+=("$gcc")
+    done < <(find "${path_array[@]}" -maxdepth 1 -regex '.*/gcc-[0-9\.]+$' -printf '%f\n' | sort -t- -k2 -V -r)
+    echo "${gccs[@]}"
+}
+
 # Find the most recent GCC version supported by the kernel sources
 select_compiler() {
     local selected_cc
@@ -92,8 +126,17 @@ select_compiler() {
 
     set +e
 
-    for cc in gcc-5 gcc-4.8; do
-      if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
+    for cc in $(list_gccs) ; do
+        if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
+            cc_version=$(echo "${cc}" | cut -d'-' -f2)
+            if { verlt "${kversion}" "5.17"; } && { vergt "${cc_version}" "11"; } ; then
+                # Using gcc-12+ with '-Wuse-after-free' breaks the build of older
+                # kernels (in particular, objtool). Some releases on LTS
+                # branches between 4.x and 5.15 can be built with gcc-12.
+                # @see https://lore.kernel.org/lkml/20494.1643237814@turing-police/
+                # @see https://gitlab.com/linux-kernel/stable/-/commit/52a9dab6d892763b2a8334a568bd4e2c1a6fde66
+                continue
+            fi
         selected_cc="$cc"
         break
       fi
@@ -101,35 +144,107 @@ select_compiler() {
 
     set -e
 
+    # Force gcc-4.8 for kernels before 4.4
+    if { verlt "$kversion" "4.4"; }; then
+        selected_cc='gcc-4.8'
+    fi
+
     if [ "x$selected_cc" = "x" ]; then
       echo "Found no suitable compiler."
       exit 1
     fi
 
-    # Force gcc-4.8 for kernels before 3.18
-    if { verlt "$kversion" "3.18"; }; then
-      selected_cc=gcc-4.8
-    fi
-
+    _KAFLAGS=()
+    _KCFLAGS=()
+    _KCPPFLAGS=()
+    _HOSTCFLAGS=()
     if [ "$selected_cc" != "gcc-4.8" ]; then
         # Older kernel Makefiles do not expect the compiler to default to PIE
-        KAFLAGS="-fno-pie"
-        KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
-        KCPPFLAGS="-fno-pie"
-        export KAFLAGS KCFLAGS KCPPFLAGS
+        _KAFLAGS+=(-fno-pie)
+        _KCFLAGS+=(
+            -fno-pie
+            -no-pie
+            -fno-stack-protector
+        )
+        _KCPPFLAGS+=(-fno-pie)
+    fi
+
+    selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
+    if { vergte "${selected_cc_version}" "10"; } && { verlt "${kversion}" "5.10"; } ; then
+        # gcc-10 changed the default from '-fcommon' to '-fno-common', which
+        # causes a linker failure. '-fcommon' can be set on the HOSTCFLAGS
+        # to avoid the issue.
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/e33a814e772cdc36436c8c188d8c42d019fda639
+        _HOSTCFLAGS+=(-fcommon)
     fi
 
+    if [ "${cross_arch:-}" == "armhf" ] ; then
+        if { verlt "${kversion}" "5.14"; } ; then
+            # Work-around for producing instructions that aren't valid for the
+            # default architectures.
+            # Eg. Error: selected processor does not support `cpsid i' in ARM mode
+            _KCFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
+            _KCPPFLAGS+=(-march=armv7-a -mfpu=vfpv3-d16)
+        fi
+    fi
+
+    if { vergt "${selected_cc_version}" "8"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
+        # This was added to -Wall in gcc 9 but some kernels do not include the fixes
+        # @see https://gcc.gnu.org/bugzilla/show_bug.cgi?id=88583
+        _KCFLAGS+=(-Wno-error=packed-not-aligned)
+    fi
+
+    export KAFLAGS="${_KAFLAGS[*]}"
+    export KCFLAGS="${_KCFLAGS[*]}"
+    export KCPPFLAGS="${_KCPPFLAGS[*]}"
+    export HOSTCFLAGS="${_HOSTCFLAGS[*]}"
     export CC="${CROSS_COMPILE:-}${selected_cc}"
     export HOSTCC="${selected_cc}"
 
+    make_args=(
+        CC="${CC}"
+        HOSTCC="${HOSTCC}"
+        HOSTCFLAGS="${HOSTCFLAGS:-}"
+    )
+    if [ -n "${DEBUG}" ] ; then
+        make_args+=(
+            V=1
+        )
+    fi
     cd -
 }
 
+patch_linux_kernel() {
+    local commit_hash
+    commit_hash="$1"
+    set +e
+    git -C "${LINUX_GIT_REF_REPO_DIR}" format-patch -n1 --stdout "${commit_hash}" | patch -p1
+    set -e
+    if [ "$?" -gt 1 ] ; then
+        echo "Serious issue patching"
+        exit 1
+    fi
+}
 
 build_linux_kernel() {
     cd "$LINUX_SRCOBJ_DIR"
 
-    kversion=$(make -s kernelversion)
+    kversion=$(make -s kernelversion "${make_args[@]}")
+    pahole_version="$(pahole --version | tr -d 'v')"
+
+    if { verlt "${kversion}" "3.3"; } && [ "${vanilla_config}" = "imx_v6_v7_defconfig" ] ; then
+        # imx_v6_v7 didn't exist before 06965c39b4c63933fa0a1cde2237ef85477c5655
+        if { verlt "${kversion}" "3.2"; } ; then
+            vanilla_config='mx5_defconfig'
+        else
+            vanilla_config='mx51_defconfig'
+        fi
+    fi
+
+    if { verlt "${kversion}" "3.13"; } && [ "${vanilla_config}" = "pseries_le_defconfig" ] ; then
+        # pseries_le_deconfig was introduced in f53e462e907cbaed29c49c0f10f5b8f614e1bf1d
+        vanilla_config='pseries_defconfig'
+    fi
 
     # Generate kernel configuration
     case "$ktag" in
@@ -140,8 +255,25 @@ build_linux_kernel() {
             exit 0
           fi
         fi
+
+        # Disable riscv64 config generation, we don't have a toolchain on bionic
+        sed -i 's/riscv64 //' debian.master/etc/kernelconfig
+
         fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
-        fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
+
+        # Hack for kernel Ubuntu-hwe-5.8
+        # The debian/control file is produced by the clean target above, so this
+        # check needs to happen afterwards.
+        if [ ! -f "debian/compat" ] && ! grep -q debhelper-compat debian/control; then
+            echo "10" > "debian/compat"
+        fi
+
+        # genconfigs check can fail in certain cases, eg. when a more recent
+        # compiler exposes kernel configuration flags which aren't set in the
+        # Ubuntu annotations.
+        # In any case, the configuration will be updated with any missing values
+        # later in our build script.
+        fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=. do_skip_checks=true
         cp CONFIGS/"${ubuntu_config}" .config
         ;;
 
@@ -151,15 +283,20 @@ build_linux_kernel() {
             export ARCH="i386"
         fi
 
-        # allyesconfig is mostly broken for kernels of the 2.6 series
-        if verlt "$kversion" "3.0"; then
-            vanilla_config="defconfig"
-        fi
-
-        make "${vanilla_config}"
+        make "${vanilla_config}" "${make_args[@]}"
         ;;
     esac
 
+    if [ "${vanilla_config}" = "pseries_defconfig" ] && [ "${cross_arch}" = "ppc64el" ] ; then
+        # @see diff <(git show v3.13:arch/powerpc/configs/pseries_defconfig) <(git show v3.13:arch/powerpc/configs/pseries_le_defconfig)
+        scripts/config --enable CONFIG_CPU_LITTLE_ENDIAN
+        scripts/config --enable CONFIG_CMA
+        scripts/config --disable CONFIG_XMON_DEFAULT
+        # scripts/config --disable CONFIG_VIRTUALIZATION
+        # scripts/config --disable CONFIG_KVM_BOOK3S_64
+        scripts/config --disable CONFIG_KVM_BOOK3S_64_HV
+    fi
+
     # oldnoconfig was renamed in 4.19
     if vergte "$kversion" "4.19"; then
         update_conf_target="olddefconfig"
@@ -183,6 +320,130 @@ build_linux_kernel() {
       fi
     fi
 
+    if { verlt "${kversion}" "5.11"; } && { vergte "${kversion}" "4.10"; } ; then
+        # Binutils > 2.35 strips empty symbol tables, causing obltool to fail
+        # in certain cases when files are empty.
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/1d489151e9f9d1647110277ff77282fe4d96d09b
+        #
+        # There doesn't seem to be any LD/AS/AR flags to control this behaviour,
+        # therefore patching tools/objtool/elf.c is attempted.
+        patch_linux_kernel 1d489151e9f9d1647110277ff77282fe4d96d09b
+        if { verlt "${kversion}" "4.18"; } ; then
+            patch_linux_kernel e81e0724432542af8d8c702c31e9d82f57b1ff31
+        fi
+    fi
+
+    if { vergt "${selected_cc_version}" "7"; } && { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ; then
+        # Builds fail due to -Werror=restrict in pager.o and str_error_r.o
+        if { verlt "${kversion}" "4.16"; } ; then
+            # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
+            # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=ad343a98e74e85aa91d844310e797f96fee6983b
+            patch_linux_kernel ad343a98e74e85aa91d844310e797f96fee6983b
+        fi
+        if { verlt "${kversion}" "4.17"; } ; then
+            # This is patched since objtool's Makefile doesn't respect HOSTCFLAGS
+            # @see https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/commit/?id=854e55ad289ef8888e7991f0ada85d5846f5afb9
+            patch_linux_kernel 854e55ad289ef8888e7991f0ada85d5846f5afb9
+        fi
+
+        # More recent compiler optimizations expose build errors with netronome.
+        # It seems easier to disable the driver than to attempt patching.
+        scripts/config --disable CONFIG_NET_VENDOR_NETRONOME
+        scripts/config --disable CONFIG_MICREL_PHY
+
+        # Duplicate decalarations of __force_order
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/df6d4f9db79c1a5d6f48b59db35ccd1e9ff9adfc
+        # However, kaslr_64.c doesn't exit in 4.15, 4.16, it's named pagetable.c
+        if [ -f arch/x86/boot/compressed/pagetable.c ] ; then
+            sed -i '/^unsigned long __force_order;$/d' arch/x86/boot/compressed/pagetable.c
+        fi
+    fi
+
+    if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.18"; } ; then
+        # Some old kernels fail to build when make is too new
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
+        patch_linux_kernel 9564a8cf422d7b58f6e857e3546d346fa970191e
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/9feeb638cde083c737e295c0547f1b4f28e99583
+        patch_linux_kernel 9feeb638cde083c737e295c0547f1b4f28e99583
+    fi
+
+    if { vergte "${kversion}" "4.12"; } && { verlt "${kversion}" "4.18"; } ; then
+        # Old kernels can fail to build while on newer host kernels
+        # @see https://gitlab.com/linux-kernel/stable/-/commit/dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
+        #
+        patch_linux_kernel dfbd199a7cfe3e3cd8531e1353cdbd7175bfbc5e
+    fi
+
+    if { vergte "${kversion}" "3.18"; } && { verlt "${kversion}" "4.4"; } ; then
+        # Compatibility with binutils >= ~ 2.31
+        patch_linux_kernel b21ebf2fb4cde1618915a97cc773e287ff49173e
+    fi
+
+    # The above patch only partially applies linux 3.17, and has been, so a
+    # rebased version is used instead.
+    if { vergte "${kversion}" "3.17"; } && { verlt "${kversion}" "3.18"; } ; then
+        cat <<'EOF' | patch -p1
+diff --git a/arch/x86/kernel/machine_kexec_64.c b/arch/x86/kernel/machine_kexec_64.c
+index 48598105..0652c5b6 100644
+--- a/arch/x86/kernel/machine_kexec_64.c
++++ b/arch/x86/kernel/machine_kexec_64.c
+@@ -516,6 +516,7 @@ int arch_kexec_apply_relocations_add(const Elf64_Ehdr *ehdr,
+                               goto overflow;
+                       break;
+               case R_X86_64_PC32:
++              case R_X86_64_PLT32:
+                       value -= (u64)address;
+                       *(u32 *)location = value;
+                       break;
+diff --git a/arch/x86/kernel/module.c b/arch/x86/kernel/module.c
+index e69f9882..7c6bc9fe 100644
+--- a/arch/x86/kernel/module.c
++++ b/arch/x86/kernel/module.c
+@@ -180,6 +180,7 @@ int apply_relocate_add(Elf64_Shdr *sechdrs,
+                               goto overflow;
+                       break;
+               case R_X86_64_PC32:
++              case R_X86_64_PLT32:
+                       val -= (u64)loc;
+                       *(u32 *)loc = val;
+ #if 0
+diff --git a/arch/x86/tools/relocs.c b/arch/x86/tools/relocs.c
+index bbb1d225..8deeacbc 100644
+--- a/arch/x86/tools/relocs.c
++++ b/arch/x86/tools/relocs.c
+@@ -763,6 +763,7 @@ static int do_reloc64(struct section *sec, Elf_Rel *rel, ElfW(Sym) *sym,
+       switch (r_type) {
+       case R_X86_64_NONE:
+       case R_X86_64_PC32:
++      case R_X86_64_PLT32:
+               /*
+                * NONE can be ignored and PC relative relocations don't
+                * need to be adjusted.
+EOF
+    fi
+
+    if ( { vergte "${kversion}" "3.15"; } && { verlt "${kversion}" "4.4"; } ) ||
+       ( { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.17"; } ); then
+        # While the original motivation of this patch is for fixing builds using
+        # clang, the same error occurs between linux >= 3.15 and < 4.4, and in
+        # 4.15, 4.16.
+        #
+        # This patch only partially applies due to changes in kernel/Makefile,
+        # so a supplementary patch is needed
+        #
+        # Without this patch, builds fail with
+        #   Cannot find symbol for section 2: .text.
+        #   kernel/elfcore.o: failed
+        #
+        # @see https://github.com/linuxppc/issues/issues/388
+        # @see https://lore.kernel.org/lkml/20201204165742.3815221-2-arnd@kernel.org/
+        #
+        patch_linux_kernel 6e7b64b9dd6d96537d816ea07ec26b7dedd397b9
+        if grep -q elfcore.o kernel/Makefile ; then
+            sed -i '/^.* += elfcore.o$/d' kernel/Makefile
+        fi
+    fi
+
     # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
     # Convert them to 'cmpw' which was previously done silently
     if verlt "$kversion" "4.9"; then
@@ -210,9 +471,43 @@ build_linux_kernel() {
       echo "header-y += linkage.h" >> include/linux/Kbuild
     fi
 
+    if [ "${cross_arch}" = "powerpc" ] ; then
+        if { vergte "${kversion}" "4.15"; } && { verlt "${kversion}" "4.16"; } ; then
+            # Avoid register errors such as
+            # aes_generic.c:(.text+0x4e0): undefined reference to `_restgpr_31_x'
+            # @see https://gitlab.com/linux-kernel/stable/-/commit/148b974deea927f5dbb6c468af2707b488bfa2de
+            make_args+=(
+                CFLAGS_aes_generic.o=''
+            )
+        fi
+    fi
+
+    if [ "$(scripts/config --state CONFIG_DEBUG_INFO_BTF)" == "y" ] &&
+           { vergte "${pahole_version}" "1.24"; } &&
+           { vergte "${kversion}" "5.10"; } && { verlt "${kversion}" "6.0"; } ;then
+        # Some kernels Eg. Ubuntu-hwe-5.13-5.13.0-52.59_20.04.1
+        # fail with the following error:
+        #   BTFIDS  vmlinux
+        #   FAILED: load BTF from vmlinux: Invalid argument
+        #
+        # When CONFIG_DEBUG_INFO_BTF is set, certain versions of pahole require
+        # `--skip_encoding_btf_enum64` to be passed as the kernel doesn't define
+        # BTF_KIND_ENUM64.
+        #
+        # Introduced in 341dfcf8d78eaa3a2dc96dea06f0392eb2978364 (~v5.10)
+        # @see https://lore.kernel.org/bpf/20220825171620.cioobudss6ovyrkc@altlinux.org/t/
+        #
+        if [ -f "scripts/pahole-flags.sh" ] ; then
+            sed -i 's/ -J ${PAHOLE_FLAGS} / -J ${PAHOLE_FLAGS} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
+        else
+            sed -i 's/ -J ${extra_paholeopt} / -J ${extra_paholeopt} --skip_encoding_btf_enum64 /' scripts/link-vmlinux.sh
+        fi
+    fi
+
     # GCC 4.8
     if [ "$HOSTCC" == "gcc-4.8" ]; then
-      scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
+        scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
+        scripts/config --disable CONFIG_PPC_OF_BOOT_TRAMPOLINE
     fi
 
     # Don't try to sign modules
@@ -246,6 +541,10 @@ build_linux_kernel() {
       scripts/config --disable CONFIG_IGBVF
     fi
 
+    # Don't fail the build on warnings
+    scripts/config --disable CONFIG_WERROR
+    scripts/config --enable CONFIG_PPC_DISABLE_WERROR
+
     # Set required options
     scripts/config --enable CONFIG_TRACEPOINTS
     scripts/config --enable CONFIG_KALLSYMS
@@ -259,18 +558,19 @@ build_linux_kernel() {
     scripts/config --enable CONFIG_EVENT_TRACING
     scripts/config --enable CONFIG_KRETPROBES
 
-    # Debug
-    #cat .config
+    if [ -n "${DEBUG}" ] ; then
+        cat .config
+    fi
 
-    make "$update_conf_target" CC="$CC"
-    make -j"$NPROC" CC="$CC"
+    make "$update_conf_target" "${make_args[@]}"
+    make -j"$NPROC" "${make_args[@]}"
 
-    krelease=$(make -s kernelrelease CC="$CC")
+    krelease=$(make -s kernelrelease "${make_args[@]}")
 
     # Save the kernel and modules
     mkdir -p "$LINUX_INSTOBJ_DIR/boot"
-    make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
-    make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
+    make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install "${make_args[@]}"
+    make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install "${make_args[@]}"
     rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
     ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
     ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
@@ -314,7 +614,9 @@ extract_distro_headers() {
 
     # On powerpc 32bits this object is required to link modules
     if [ "${karch}" = "powerpc" ]; then
-        if [ "x$(scripts/config -s CONFIG_PPC64)" = "xn" ]; then
+        if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
+            :
+        else
             cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
         fi
     fi
@@ -364,25 +666,29 @@ extract_distro_headers() {
     touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
 
     # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
-    cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
+    if [ ! -f "${LINUX_HDROBJ_DIR}/include/config/auto.conf" ]; then
+        cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
+    fi
 
     # Finally clean the object files from the full source tree
     make clean
 
     # And regen the modules support files
-    make modules_prepare CC="$CC"
+    make modules_prepare "${make_args[@]}"
 
     # On powerpc 32bits this object is required to link modules
     if [ "${karch}" = "powerpc" ]; then
-        if [ "x$(scripts/config -s CONFIG_PPC64)" = "xn" ]; then
-            make arch/powerpc/lib/crtsavres.o CC="$CC"
+        if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
+            :
+        else
+            make arch/powerpc/lib/crtsavres.o "${make_args[@]}"
         fi
     fi
 
     # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
     if [ "${karch}" = "arm64" ]; then
         if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
-            make arch/arm64/kernel/ftrace-mod.o CC="$CC"
+            make arch/arm64/kernel/ftrace-mod.o "${make_args[@]}"
         fi
     fi
 
@@ -406,6 +712,10 @@ build_modules() {
 
     kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
 
+    # Try to catch some compatibility problems by turning some
+    # warnings into errors.
+    #export KCFLAGS="$KCFLAGS -Wall -Werror"
+
     # Enter lttng-modules source dir
     cd "${MODULES_GIT_DIR}"
 
@@ -417,7 +727,7 @@ build_modules() {
         set +e
 
         # Build modules
-        KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
+        KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
        ret=$?
 
         set -e
@@ -436,7 +746,7 @@ build_modules() {
     else # Regular build
 
         # Build modules against full kernel sources
-        KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
+        KERNELDIR="${kdir}" make -j"${NPROC}" V=1 "${make_args[@]}"
 
         # Install modules to build dir
         KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
@@ -522,37 +832,37 @@ elif [ "x${arch}" != "x" ]; then
     case "$arch" in
         "i386")
             karch="x86"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="i386-config.flavour.generic"
             ;;
 
         "amd64")
             karch="x86"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="amd64-config.flavour.generic"
             ;;
 
         "armhf")
             karch="arm"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="armhf-config.flavour.generic"
             ;;
 
         "arm64")
             karch="arm64"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="arm64-config.flavour.generic"
             ;;
 
         "powerpc")
             karch="powerpc"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="powerpc-config.flavour.powerpc-smp"
             ;;
 
         "ppc64el")
             karch="powerpc"
-            vanilla_config="allyesconfig"
+            vanilla_config="allmodconfig"
             ubuntu_config="ppc64el-config.flavour.generic"
             ;;
 
@@ -586,16 +896,26 @@ signature_v2 = False" > "$WORKSPACE/.s3cfg"
 
 url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
 obj_name="linux.tar.bz2"
-obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
+
+if [ "x${cross_arch}" = "x" ]; then
+       obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/$arch/native"
+else
+       obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/platform-${platforms}/${cross_arch}"
+fi
+
 obj_url="$obj_url_prefix/$obj_name"
 
 set +e
-s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
+# In s3cmd 2.3, the return code of get when an object does not exist (64)
+# is different than in 2.2 (12). The return codes of 's3cmd info' are
+# consistent between 2.2 and 2.3.
+s3cmd -c "$WORKSPACE/.s3cfg" info "$obj_url"
 ret=$?
 set -e
 
 case "$ret" in
     "0")
+      s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
       extract_archive_obj
       ;;
 
@@ -630,6 +950,14 @@ esac
 
 select_compiler
 
+selected_cc_version="$(echo "${selected_cc}" | cut -d'-' -f2)"
+# lttng-modules requires gcc >= 5.1 for aarch64
+# @see https://github.com/lttng/lttng-modules/commit/be06402dbdbea2f3394e60ec15c5d3356e2be416
+if { verlt "${selected_cc_version}" "5.1"; } && [ "${cross_arch}" = "arm64" ] ; then
+    echo "Building lltng-modules on aarch64 requires gcc >= 5.1"
+    exit 0
+fi
+
 ## BUILD modules
 # Either we downloaded a pre-build kernel or we built it and uploaded
 # the archive for future builds.
This page took 0.029674 seconds and 4 git commands to generate.